diff -urN sbcl-0.8.16/src/code/target-pathname.lisp sbcl-0.8.16.patched/src/code/target-pathname.lisp
--- sbcl-0.8.16/src/code/target-pathname.lisp	2004-06-01 17:27:26.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-pathname.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -44,11 +44,11 @@
   (let ((namestring (handler-case (namestring pathname)
 		      (error nil))))
     (if namestring
-	(format stream "#P~S" namestring)
+	(format stream "#P~S" (coerce namestring '(simple-array character (*))))
 	(print-unreadable-object (pathname stream :type t)
 	  (format stream
 		  "~@<(with no namestring) ~_:HOST ~S ~_:DEVICE ~S ~_:DIRECTORY ~S ~
-		  ~_:NAME ~S ~_:TYPE ~S ~_:VERSION ~S~:>"
+                  ~_:NAME ~S ~_:TYPE ~S ~_:VERSION ~S~:>"
 		  (%pathname-host pathname)
 		  (%pathname-device pathname)
 		  (%pathname-directory pathname)
@@ -202,12 +202,12 @@
   (or (eq thing wild)
       (eq wild :wild)
       (typecase thing
-	(simple-base-string
+	(simple-string
 	 ;; String is matched by itself, a matching pattern or :WILD.
 	 (typecase wild
 	   (pattern
 	    (values (pattern-matches wild thing)))
-	   (simple-base-string
+	   (simple-string
 	    (string= thing wild))))
 	(pattern
 	 ;; A pattern is only matched by an identical pattern.
@@ -308,7 +308,7 @@
 		    (dolist (x in)
 		      (when (check-for pred x)
 			(return t))))
-		   (simple-base-string
+		   (simple-string
 		    (dotimes (i (length in))
 		      (when (funcall pred (schar in i))
 			(return t))))
@@ -319,7 +319,7 @@
 		    (make-pattern
 		     (mapcar (lambda (piece)
 			       (typecase piece
-				 (simple-base-string
+				 (simple-string
 				  (funcall fun piece))
 				 (cons
 				  (case (car piece)
@@ -333,7 +333,7 @@
 			     (pattern-pieces thing))))
 		   (list
 		    (mapcar fun thing))
-		   (simple-base-string
+		   (simple-string
 		    (funcall fun thing))
 		   (t
 		    thing))))
@@ -385,6 +385,7 @@
   (declare (type pathname-designator pathname)
 	   (type pathname-designator defaults)
 	   (values pathname))
+  (/show0 "in MERGE-PATHNAMES")
   (with-pathname (defaults defaults)
     (let ((pathname (let ((*default-pathname-defaults* defaults))
 		      (pathname pathname))))
@@ -692,7 +693,7 @@
 		  :expected-type 'null
 		  :format-control
 		  "The host in the namestring, ~S,~@
-		    does not match the explicit HOST argument, ~S."
+                   does not match the explicit HOST argument, ~S."
 		  :format-arguments (list new-host host)))
 	 (let ((pn-host (or new-host host (pathname-host defaults))))
 	   (values (%make-maybe-logical-pathname
@@ -702,7 +703,7 @@
 ;;; If NAMESTR begins with a colon-terminated, defined, logical host,
 ;;; then return that host, otherwise return NIL.
 (defun extract-logical-host-prefix (namestr start end)
-  (declare (type simple-base-string namestr)
+  (declare (type simple-string namestr)
 	   (type index start end)
 	   (values (or logical-host null)))
   (let ((colon-pos (position #\: namestr :start start :end end)))
@@ -816,7 +817,7 @@
       (let ((host (%pathname-host pathname)))
 	(unless host
 	  (error "can't determine the namestring for pathnames with no ~
-		  host:~%  ~S" pathname))
+                  host:~%  ~S" pathname))
 	(funcall (host-unparse host) pathname)))))
 
 (defun host-namestring (pathname)
@@ -924,7 +925,7 @@
 (defun substitute-into (pattern subs diddle-case)
   (declare (type pattern pattern)
 	   (type list subs)
-	   (values (or simple-base-string pattern) list))
+	   (values (or simple-string pattern) list))
   (let ((in-wildcard nil)
 	(pieces nil)
 	(strings nil))
@@ -937,7 +938,7 @@
 	     (setf in-wildcard t)
 	     (unless subs
 	       (error "not enough wildcards in FROM pattern to match ~
-		       TO pattern:~%  ~S"
+                       TO pattern:~%  ~S"
 		      pattern))
 	     (let ((sub (pop subs)))
 	       (typecase sub
@@ -952,7 +953,7 @@
 		  (push sub strings))
 		 (t
 		  (error "can't substitute this into the middle of a word:~
-			  ~%  ~S"
+                          ~%  ~S"
 			 sub)))))))
 
     (when strings
@@ -969,7 +970,7 @@
 ;;; Called when we can't see how source and from matched.
 (defun didnt-match-error (source from)
   (error "Pathname components from SOURCE and FROM args to TRANSLATE-PATHNAME~@
-	  did not match:~%  ~S ~S"
+          did not match:~%  ~S ~S"
 	 source from))
 
 ;;; Do TRANSLATE-COMPONENT for all components except host, directory
@@ -1082,14 +1083,14 @@
 	       (let ((match (pop subs-left)))
 		 (when (listp match)
 		   (error ":WILD-INFERIORS is not paired in from and to ~
-			   patterns:~%  ~S ~S" from to))
+                           patterns:~%  ~S ~S" from to))
 		 (res (maybe-diddle-case match diddle-case))))
 	      ((member :wild-inferiors)
 	       (aver subs-left)
 	       (let ((match (pop subs-left)))
 		 (unless (listp match)
 		   (error ":WILD-INFERIORS not paired in from and to ~
-			   patterns:~%  ~S ~S" from to))
+                           patterns:~%  ~S ~S" from to))
 		 (dolist (x match)
 		   (res (maybe-diddle-case x diddle-case)))))
 	      (pattern
@@ -1157,13 +1158,14 @@
   (let ((word (string-upcase word)))
     (dotimes (i (length word))
       (let ((ch (schar word i)))
-	(unless (or (alpha-char-p ch) (digit-char-p ch) (char= ch #\-))
+	(unless (and (typep ch 'standard-char)
+		     (or (alpha-char-p ch) (digit-char-p ch) (char= ch #\-)))
 	  (error 'namestring-parse-error
 		 :complaint "logical namestring character which ~
-			     is not alphanumeric or hyphen:~%  ~S"
+                             is not alphanumeric or hyphen:~%  ~S"
 		 :args (list ch)
 		 :namestring word :offset i))))
-    word))
+    (coerce word 'base-string)))
 
 ;;; Given a logical host or string, return a logical host. If ERROR-P
 ;;; is NIL, then return NIL when no such host exists.
@@ -1213,7 +1215,7 @@
 		(when (pattern)
 		  (error 'namestring-parse-error
 			 :complaint "double asterisk inside of logical ~
-				     word: ~S"
+                                     word: ~S"
 			 :args (list chunk)
 			 :namestring namestring
 			 :offset (+ (cdar chunks) pos)))
@@ -1257,7 +1259,7 @@
 ;;; Break up a logical-namestring, always a string, into its
 ;;; constituent parts.
 (defun parse-logical-namestring (namestr start end)
-  (declare (type simple-base-string namestr)
+  (declare (type simple-string namestr)
 	   (type index start end))
   (collect ((directory))
     (let ((host nil)
@@ -1332,7 +1334,7 @@
 		       (unless (and res (plusp res))
 			 (error 'namestring-parse-error
 				:complaint "expected a positive integer, ~
-					    got ~S"
+                                            got ~S"
 				:args (list str)
 				:namestring namestr
 				:offset (+ pos (cdar chunks))))
@@ -1418,7 +1420,7 @@
       (when type-supplied
 	(unless name
 	  (error "cannot specify the type without a file: ~S" pathname))
-	(when (typep type 'simple-base-string)
+	(when (typep type 'simple-string)
 	  (when (position #\. type)
 	    (error "type component can't have a #\. inside: ~S" pathname)))
 	(strings ".")
@@ -1524,12 +1526,9 @@
     (t (translate-logical-pathname (pathname pathname)))))
 
 (defvar *logical-pathname-defaults*
-  (%make-logical-pathname (make-logical-host :name "BOGUS")
-			  :unspecific
-			  nil
-			  nil
-			  nil
-			  nil))
+  (%make-logical-pathname
+   (make-logical-host :name (logical-word-or-lose "BOGUS"))
+   :unspecific nil nil nil nil))
 
 (defun load-logical-pathname-translations (host)
   #!+sb-doc
diff -urN sbcl-0.8.16/src/code/target-thread.lisp sbcl-0.8.16.patched/src/code/target-thread.lisp
--- sbcl-0.8.16/src/code/target-thread.lisp	2004-10-06 08:22:31.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-thread.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -58,7 +58,7 @@
 (declaim (inline waitqueue-data-address mutex-value-address))
 
 (defstruct waitqueue
-  (name nil :type (or null simple-base-string))
+  (name nil :type (or null simple-string))
   (lock 0)
   (data nil))
 
diff -urN sbcl-0.8.16/src/code/target-type.lisp sbcl-0.8.16.patched/src/code/target-type.lisp
--- sbcl-0.8.16/src/code/target-type.lisp	2003-07-11 18:48:48.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-type.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -33,6 +33,7 @@
 	 named-type
 	 member-type
 	 array-type
+	 character-set-type
 	 built-in-classoid
 	 cons-type)
      (values (%typep obj type) t))
@@ -191,6 +192,8 @@
 			:specialized-element-type etype)))
     (cons
      (make-cons-type *universal-type* *universal-type*))
+    (character
+     (specifier-type 'character))
     (t
      (classoid-of x))))
 
diff -urN sbcl-0.8.16/src/code/target-unithread.lisp sbcl-0.8.16.patched/src/code/target-unithread.lisp
--- sbcl-0.8.16/src/code/target-unithread.lisp	2004-07-20 01:44:45.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-unithread.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -37,7 +37,7 @@
 ;;;; the higher-level locking operations are based on waitqueues
 
 (defstruct waitqueue
-  (name nil :type (or null simple-base-string))
+  (name nil :type (or null simple-string))
   (lock 0)
   (data nil))
 
diff -urN sbcl-0.8.16/src/code/toplevel.lisp sbcl-0.8.16.patched/src/code/toplevel.lisp
--- sbcl-0.8.16/src/code/toplevel.lisp	2004-09-13 09:14:41.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/toplevel.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -421,6 +421,7 @@
              (probe-init-files (explicitly-specified-init-file-name
 				&rest default-init-file-names)
                (declare (type list default-init-file-names))
+	       (/show0 "in PROBE-INIT-FILES")
 	       (if explicitly-specified-init-file-name
 		   (or (probe-file explicitly-specified-init-file-name)
                         (startup-error "The file ~S was not found."
@@ -431,6 +432,7 @@
 	     ;; shared idiom for creating default names for
 	     ;; SYSINITish and USERINITish files
 	     (init-file-name (maybe-dir-name basename)
+	       (/show0 "in INIT-FILE-NAME")
 	       (and maybe-dir-name
 		    (concatenate 'string maybe-dir-name "/" basename))))
         (let ((sysinit-truename
diff -urN sbcl-0.8.16/src/code/typecheckfuns.lisp sbcl-0.8.16.patched/src/code/typecheckfuns.lisp
--- sbcl-0.8.16/src/code/typecheckfuns.lisp	2003-06-12 08:41:13.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/typecheckfuns.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -199,7 +199,11 @@
 	   (member-type-p ctype)
 	   (numeric-type-p ctype)
 	   (array-type-p ctype)
-	   (cons-type-p ctype))))
+	   (cons-type-p ctype)
+	   (intersection-type-p ctype)
+	   (union-type-p ctype)
+	   (negation-type-p ctype)
+	   (character-range-type-p ctype))))
 
 ;;; Evaluate (at load/execute time) to a function which checks that
 ;;; its argument is of the specified type.
diff -urN sbcl-0.8.16/src/code/typep.lisp sbcl-0.8.16.patched/src/code/typep.lisp
--- sbcl-0.8.16/src/code/typep.lisp	2003-05-03 17:32:28.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/typep.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -117,6 +117,14 @@
      (and (consp object)
 	  (%%typep (car object) (cons-type-car-type type))
 	  (%%typep (cdr object) (cons-type-cdr-type type))))
+    (character-set-type
+     (and (characterp object)
+	  (let ((code (char-code object))
+		(pairs (character-set-type-pairs type)))
+	    (dolist (pair pairs nil)
+	      (destructuring-bind (low . high) pair
+		(when (<= low code high)
+		  (return t)))))))
     (unknown-type
      ;; dunno how to do this ANSIly -- WHN 19990413
      #+sb-xc-host (error "stub: %%TYPEP UNKNOWN-TYPE in xcompilation host")
diff -urN sbcl-0.8.16/src/code/unix.lisp sbcl-0.8.16.patched/src/code/unix.lisp
--- sbcl-0.8.16/src/code/unix.lisp	2004-09-27 14:57:33.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/unix.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -811,7 +811,7 @@
 ;;; paths have been converted to absolute paths, so we don't need to
 ;;; try to handle any more generality than that.
 (defun unix-resolve-links (pathname)
-  (declare (type simple-string pathname))
+  (declare (type simple-base-string pathname))
   (aver (not (relative-unix-pathname? pathname)))
   (/noshow "entering UNIX-RESOLVE-LINKS")
   (loop with previous-pathnames = nil do
@@ -837,7 +837,7 @@
 							:from-end t)))
 				 (dir (subseq pathname 0 dir-len)))
 			    (/noshow dir)
-			    (concatenate 'string dir link))
+			    (concatenate 'base-string dir link))
 			  link))))
 		(if (unix-file-kind new-pathname)
 		    (setf pathname new-pathname)
@@ -853,9 +853,9 @@
 	    (push pathname previous-pathnames))))
 
 (defun unix-simplify-pathname (src)
-  (declare (type simple-string src))
+  (declare (type simple-base-string src))
   (let* ((src-len (length src))
-	 (dst (make-string src-len))
+	 (dst (make-string src-len :element-type 'base-char))
 	 (dst-len 0)
 	 (dots 0)
 	 (last-slash nil))
@@ -929,7 +929,8 @@
 		  (position #\/ dst :end last-slash :from-end t)))
 	     (if prev-prev-slash
 		 (setf dst-len (1+ prev-prev-slash))
-		 (return-from unix-simplify-pathname "./")))))))
+		 (return-from unix-simplify-pathname
+		   (coerce "./" 'simple-base-string))))))))
     (cond ((zerop dst-len)
 	   "./")
 	  ((= dst-len src-len)
diff -urN sbcl-0.8.16/src/cold/shebang.lisp sbcl-0.8.16.patched/src/cold/shebang.lisp
--- sbcl-0.8.16/src/cold/shebang.lisp	2002-03-14 16:10:45.000000000 +0100
+++ sbcl-0.8.16.patched/src/cold/shebang.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -73,6 +73,17 @@
 (declaim (type list *shebang-features*))
 (defvar *shebang-backend-subfeatures*)
 
+;;;; string checker, for catching non-portability early
+(defun make-quote-reader (standard-quote-reader)
+  (lambda (stream char)
+    (let ((result (funcall standard-quote-reader stream char)))
+      (unless (every (lambda (x) (typep x 'standard-char)) result)
+        (warn "Found non-STANDARD-CHAR in ~S" result))
+      result)))
+(compile 'make-quote-reader)
+
+(set-macro-character #\" (make-quote-reader (get-macro-character #\" nil)))
+
 ;;;; FIXME: Would it be worth implementing this?
 #|
 ;;;; readmacro syntax to remove spaces from FORMAT strings at compile time
diff -urN sbcl-0.8.16/src/cold/warm.lisp sbcl-0.8.16.patched/src/cold/warm.lisp
--- sbcl-0.8.16/src/cold/warm.lisp	2004-09-13 09:14:41.000000000 +0200
+++ sbcl-0.8.16.patched/src/cold/warm.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -73,10 +73,13 @@
 	 (make-pathname :directory '(:relative "contrib" :wild-inferiors)
 			:name :wild :type :wild)
 	 sys)))
+  (sb-int:/show "about to set SYS logical pathname translations")
   (setf (logical-pathname-translations "SYS")
 	`(("SYS:SRC;**;*.*.*" ,src)
 	  ("SYS:CONTRIB;**;*.*.*" ,contrib))))
 
+(sb-int:/show "set SYS logical pathname translations")
+
 ;;; FIXME: CMU CL's pclcom.lisp had extra optional stuff wrapped around
 ;;; COMPILE-PCL, at least some of which we should probably have too:
 ;;;
@@ -175,7 +178,7 @@
 		;; facility, and should be compiled and loaded after
 		;; our DESCRIBE facility is compiled and loaded.
 		"SRC;PCL;DESCRIBE"))
-
+  (sb-int:/show "at head of DOLIST")
   (let ((fullname (concatenate 'string "SYS:" stem ".LISP")))
     (sb-int:/show "about to compile" fullname)
     (flet ((report-recompile-restart (stream)
diff -urN sbcl-0.8.16/src/compiler/array-tran.lisp sbcl-0.8.16.patched/src/compiler/array-tran.lisp
--- sbcl-0.8.16/src/compiler/array-tran.lisp	2004-09-27 14:57:33.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/array-tran.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -293,8 +293,7 @@
       (give-up-ir1-transform
        "cannot open-code creation of ~S" result-type-spec))
     #-sb-xc-host
-    (unless (csubtypep (ctype-of (sb!vm:saetp-initial-element-default saetp))
-		       eltype-type)
+    (unless (ctypep (sb!vm:saetp-initial-element-default saetp) eltype-type)
       ;; This situation arises e.g. in (MAKE-ARRAY 4 :ELEMENT-TYPE
       ;; '(INTEGER 1 5)) ANSI's definition of MAKE-ARRAY says "If
       ;; INITIAL-ELEMENT is not supplied, the consequences of later
@@ -523,7 +522,7 @@
 	    ((:maybe)
 	     (give-up-ir1-transform
 	      "The array type is ambiguous; must call ~
-	      ARRAY-HAS-FILL-POINTER-P at runtime.")))))))
+               ARRAY-HAS-FILL-POINTER-P at runtime.")))))))
 
 ;;; Primitive used to verify indices into arrays. If we can tell at
 ;;; compile-time or we are generating unsafe code, don't bother with
diff -urN sbcl-0.8.16/src/compiler/assem.lisp sbcl-0.8.16.patched/src/compiler/assem.lisp
--- sbcl-0.8.16/src/compiler/assem.lisp	2004-07-14 22:29:51.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/assem.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -27,7 +27,7 @@
 ;;; This structure holds the state of the assembler.
 (defstruct (segment (:copier nil))
   ;; the name of this segment (for debugging output and stuff)
-  (name "unnamed" :type simple-base-string)
+  (name "unnamed" :type simple-string)
   ;; Ordinarily this is a vector where instructions are written. If
   ;; the segment is made invalid (e.g. by APPEND-SEGMENT) then the
   ;; vector can be replaced by NIL.
@@ -953,7 +953,7 @@
 		    (when (< (find-alignment additional-delta)
 			     (chooser-alignment note))
 		      (error "~S shrunk by ~W bytes, but claimed that it ~
-			      preserves ~W bits of alignment."
+                              preserves ~W bits of alignment."
 			     note additional-delta (chooser-alignment note)))
 		    (incf delta additional-delta)
 		    (emit-filler segment additional-delta))
@@ -995,7 +995,7 @@
 			 (additional-delta (- old-size size)))
 		    (when (minusp additional-delta)
 		      (error "Alignment ~S needs more space now?  It was ~W, ~
-			    and is ~W now."
+                              and is ~W now."
 			     note old-size size))
 		    (when (plusp additional-delta)
 		      (emit-filler segment additional-delta)
@@ -1387,7 +1387,7 @@
 	       (arg (gensym (format nil "~:@(ARG-FOR-~S-~)" byte-spec-expr))))
 	  (when (ldb-test (byte byte-size byte-posn) overall-mask)
 	    (error "The byte spec ~S either overlaps another byte spec, or ~
-		    extends past the end."
+                    extends past the end."
 		   byte-spec-expr))
 	  (setf (ldb byte-spec overall-mask) -1)
 	  (arg-names arg)
@@ -1650,7 +1650,7 @@
 	     (setf (segment-postits ,segment-name) nil)
 	     (macrolet ((%%current-segment%% ()
 			  (error "You can't use INST without an ~
-				  ASSEMBLE inside emitters.")))
+                                  ASSEMBLE inside emitters.")))
                ;; KLUDGE: Some host lisps (CMUCL 18e Sparc at least)
                ;; can't deal with this declaration, so disable it on host
                ;; Ditto for earlier ENABLE-PACKAGE-LOCKS %%C-S%% %%C-V%%
diff -urN sbcl-0.8.16/src/compiler/dump.lisp sbcl-0.8.16.patched/src/compiler/dump.lisp
--- sbcl-0.8.16/src/compiler/dump.lisp	2004-09-27 14:59:06.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/dump.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -33,7 +33,7 @@
   ;; can get them from the table rather than dumping them again. The
   ;; EQUAL-TABLE is used for lists and strings, and the EQ-TABLE is
   ;; used for everything else. We use a separate EQ table to avoid
-  ;; performance patholigies with objects for which EQUAL degnerates
+  ;; performance pathologies with objects for which EQUAL degenerates
   ;; to EQL. Everything entered in the EQUAL table is also entered in
   ;; the EQ table.
   (equal-table (make-hash-table :test 'equal) :type hash-table)
@@ -192,11 +192,19 @@
   (declare (type fasl-output fasl-output))
   (unless *cold-load-dump*
     (let ((handle (gethash x (fasl-output-equal-table fasl-output))))
-      (cond (handle
-	     (dump-push handle fasl-output)
-	     t)
-	    (t
-	     nil)))))
+      (cond
+        (handle (dump-push handle fasl-output) t)
+        (t nil)))))
+(defun string-check-table (x fasl-output)
+  (declare (type fasl-output fasl-output)
+           (type string x))
+  (unless *cold-load-dump*
+    (let ((handle (cdr (assoc
+                        (array-element-type x)
+                        (gethash x (fasl-output-equal-table fasl-output))))))
+      (cond
+        (handle (dump-push handle fasl-output) t)
+        (t nil)))))
 
 ;;; These functions are called after dumping an object to save the
 ;;; object in the table. The object (also passed in as X) must already
@@ -217,7 +225,16 @@
       (setf (gethash x (fasl-output-eq-table fasl-output)) handle)
       (dump-push handle fasl-output)))
   (values))
-
+(defun string-save-object (x fasl-output)
+  (declare (type fasl-output fasl-output)
+           (type string x))
+  (unless *cold-load-dump*
+    (let ((handle (dump-pop fasl-output)))
+      (push (cons (array-element-type x) handle)
+            (gethash x (fasl-output-equal-table fasl-output)))
+      (setf (gethash x (fasl-output-eq-table fasl-output)) handle)
+      (dump-push handle fasl-output)))
+  (values))
 ;;; Record X in File's CIRCULARITY-TABLE unless *COLD-LOAD-DUMP* is
 ;;; true. This is called on objects that we are about to dump might
 ;;; have a circular path through them.
@@ -280,17 +297,19 @@
     ;; character code.
     (fasl-write-string
      (with-standard-io-syntax
-       (format nil
-	       "~%  ~
-	        compiled from ~S~%  ~
-	        at ~A~%  ~
-	        on ~A~%  ~
-	        using ~A version ~A~%"
-	        where
-	        (format-universal-time nil (get-universal-time))
-	        (machine-instance)
-	        (sb!xc:lisp-implementation-type)
-	        (sb!xc:lisp-implementation-version)))
+       (let ((*print-readably* nil)
+	     (*print-pretty* nil))
+	 (format nil
+		 "~%  ~
+                  compiled from ~S~%  ~
+                  at ~A~%  ~
+                  on ~A~%  ~
+                  using ~A version ~A~%"
+	 where
+		 (format-universal-time nil (get-universal-time))
+		 (machine-instance)
+		 (sb!xc:lisp-implementation-type)
+		 (sb!xc:lisp-implementation-version))))
      stream)
     (dump-byte +fasl-header-string-stop-char-code+ res)
 
@@ -368,11 +387,8 @@
 	      (dump-structure x file)
 	      (eq-save-object x file))
 	     (array
-	      ;; FIXME: The comment at the head of
-	      ;; DUMP-NON-IMMEDIATE-OBJECT says it's for objects which
-	      ;; we want to save, instead of repeatedly dumping them.
-	      ;; But then we dump arrays here without doing anything
-	      ;; like EQUAL-SAVE-OBJECT. What gives?
+              ;; DUMP-ARRAY (and its callees) are responsible for
+              ;; updating the EQ and EQUAL hash tables.
 	      (dump-array x file))
 	     (number
 	      (unless (equal-check-table x file)
@@ -584,7 +600,14 @@
 	(t
 	 (unless *cold-load-dump*
 	   (dump-fop 'fop-normal-load file))
-	 (dump-simple-string (package-name pkg) file)
+         #+sb-xc-host
+         (dump-simple-base-string
+          (coerce (package-name pkg) 'simple-base-string)
+          file)
+         #-sb-xc-host
+	 (dump-simple-character-string
+	  (coerce (package-name pkg) '(simple-array character (*)))
+	  file)
 	 (dump-fop 'fop-package file)
 	 (unless *cold-load-dump*
 	   (dump-fop 'fop-maybe-cold-load file))
@@ -715,10 +738,21 @@
 					(*)))
 			    x)))
     (typecase simple-version
+      #+sb-xc-host
+      (simple-string
+       (unless (string-check-table x file)
+         (dump-simple-base-string simple-version file)
+         (string-save-object x file)))
+      #-sb-xc-host
       (simple-base-string
-       (unless (equal-check-table x file)
-	 (dump-simple-string simple-version file)
-	 (equal-save-object x file)))
+       (unless (string-check-table x file)
+	 (dump-simple-base-string simple-version file)
+	 (string-save-object x file)))
+      #-sb-xc-host
+      ((simple-array character (*))
+       (unless (string-check-table x file)
+	 (dump-simple-character-string simple-version file)
+	 (string-save-object x file)))
       (simple-vector
        (dump-simple-vector simple-version file)
        (eq-save-object x file))
@@ -887,23 +921,31 @@
 
 ;;; Dump characters and string-ish things.
 
-(defun dump-character (ch file)
-  (dump-fop 'fop-short-character file)
-  (dump-byte (char-code ch) file))
-
-;;; a helper function shared by DUMP-SIMPLE-STRING and DUMP-SYMBOL
-(defun dump-characters-of-string (s fasl-output)
-  (declare (type string s) (type fasl-output fasl-output))
+(defun dump-character (char file)
+  (let ((code (sb!xc:char-code char)))
+    (cond
+      ((< code 256)
+       (dump-fop 'fop-short-character file)
+       (dump-byte code file))
+      (t
+       (dump-fop 'fop-character file)
+       (dump-word code file)))))
+
+(defun dump-base-chars-of-string (s fasl-output)
+  (declare #+sb-xc-host (type simple-string s)
+           #-sb-xc-host (type simple-base-string s)
+           (type fasl-output fasl-output))
   (dovector (c s)
-    (dump-byte (char-code c) fasl-output))
+    (dump-byte (sb!xc:char-code c) fasl-output))
   (values))
 
+
 ;;; Dump a SIMPLE-BASE-STRING.
-;;; FIXME: should be called DUMP-SIMPLE-BASE-STRING then
-(defun dump-simple-string (s file)
-  (declare (type simple-base-string s))
-  (dump-fop* (length s) fop-small-string fop-string file)
-  (dump-characters-of-string s file)
+(defun dump-simple-base-string (s file)
+  #+sb-xc-host (declare (type simple-string s))
+  #-sb-xc-host (declare (type simple-base-string s))
+  (dump-fop* (length s) fop-small-base-string fop-base-string file)
+  (dump-base-chars-of-string s file)
   (values))
 
 ;;; If we get here, it is assumed that the symbol isn't in the table,
@@ -953,7 +995,8 @@
 		      file)
 	   (dump-word pname-length file)))
 
-    (dump-characters-of-string pname file)
+    #+sb-xc-host (dump-base-chars-of-string pname file)
+    #-sb-xc-host (dump-characters-of-string pname file)
 
     (unless *cold-load-dump*
       (setf (gethash s (fasl-output-eq-table file))
diff -urN sbcl-0.8.16/src/compiler/fndb.lisp sbcl-0.8.16.patched/src/compiler/fndb.lisp
--- sbcl-0.8.16/src/compiler/fndb.lisp	2004-09-13 07:40:29.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/fndb.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -421,7 +421,7 @@
   (movable foldable flushable))
 (defknown name-char (string-designator) (or character null)
   (movable foldable flushable))
-(defknown code-char (char-code) base-char
+(defknown code-char (char-code) character
   ;; By suppressing constant folding on CODE-CHAR when the
   ;; cross-compiler is running in the cross-compilation host vanilla
   ;; ANSI Common Lisp, we can use CODE-CHAR expressions to delay until
@@ -1192,7 +1192,7 @@
 					   :rename-and-delete :overwrite
 					   :append :supersede nil))
 		       (:if-does-not-exist (member :error :create nil))
-		       (:external-format (member :default)))
+		       (:external-format keyword))
   (or stream null))
 
 (defknown rename-file (pathname-designator filename)
diff -urN sbcl-0.8.16/src/compiler/generic/early-objdef.lisp sbcl-0.8.16.patched/src/compiler/generic/early-objdef.lisp
--- sbcl-0.8.16/src/compiler/generic/early-objdef.lisp	2004-08-10 02:20:45.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/early-objdef.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -136,7 +136,7 @@
   return-pc-header                  ; 00110110
   value-cell-header                 ; 00111010
   symbol-header                     ; 00111110
-  base-char                         ; 01000010
+  character                         ; 01000010
   sap                               ; 01000110
   unbound-marker                    ; 01001010
   weak-pointer                      ; 01001110
@@ -167,6 +167,7 @@
   simple-array-unsigned-byte-16     ; 10011110
   simple-array-nil                  ; 10100010
   simple-base-string                ; 10100110
+  simple-character-string
   simple-bit-vector                 ; 10101010
   simple-vector                     ; 10101110
   #!+#.(cl:if (cl:= 32 sb!vm:n-word-bits) '(and) '(or))
@@ -195,16 +196,19 @@
   simple-array                      ; 11011110
   complex-vector-nil                ; 11100010
   complex-base-string               ; 11100110
+  complex-character-string
   complex-bit-vector                ; 11101010
   complex-vector                    ; 11101110
   complex-array                     ; 11110010
 
   #!+#.(cl:if (cl:= 32 sb!vm:n-word-bits) '(and) '(or))
   unused12                          ; 11110110
+  #|
   #!+#.(cl:if (cl:= 32 sb!vm:n-word-bits) '(and) '(or))
   unused13                          ; 11111010
   #!+#.(cl:if (cl:= 32 sb!vm:n-word-bits) '(and) '(or))
   unused14                          ; 11111110
+  |#
 )
 
 ;;; the different vector subtypes
diff -urN sbcl-0.8.16/src/compiler/generic/early-type-vops.lisp sbcl-0.8.16.patched/src/compiler/generic/early-type-vops.lisp
--- sbcl-0.8.16/src/compiler/generic/early-type-vops.lisp	2003-10-10 09:33:33.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/early-type-vops.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -11,7 +11,7 @@
 (in-package "SB!VM")
 
 (defparameter *immediate-types*
-  (list unbound-marker-widetag base-char-widetag))
+  (list unbound-marker-widetag character-widetag))
 
 (defparameter *fun-header-widetags*
   (list funcallable-instance-header-widetag
@@ -57,7 +57,7 @@
 			 (if (subsetp headers *fun-header-widetags*)
 			     t
 			     (error "can't test for mix of function subtypes ~
-				     and normal header types"))
+                                     and normal header types"))
 			 nil)))
     (unless type-codes
       (error "At least one type must be supplied for TEST-TYPE."))
